/**************************************************************************/
/* Erstellt HTML-Ansicht aus Server-Check Log-Datei                 v1.0  */
/* Autor      : Thomas Nolte   (23.07.2001)                               */
/* Funktion   : Es werden HMTL-Seiten aus der Log-Datei von CHECKSRV.EXE  */
/*              erstellt. Die HTML-Seiten werden Tagesaktuell erstellt,   */
/*              alte Dateien werden vorher gelscht.                      */
/*              Zwecks der Lesbarkeit werden z.Zt. folgende Umlaute       */
/*              ersetzt: ,,,<,>                                        */
/* nderungen : -                                             (  .  .  )  */
/**************************************************************************/

if RxFuncQuery('SysLoadFuncs') then
   call RxFuncAdd 'SysLoadFuncs','REXXUTIL','SysLoadFuncs'
call SysLoadFuncs

/**************************************************************************/
/* Anzupassende Variablen                                                 */
/* Bitte nur diese Variablen verndern. Pfade ohne abschlieenden '\' !!! */
/**************************************************************************/
QuellPfad = 'E:\TOOLS\THONO\CHECKSRV\LOGS'
ZielPfad = 'F:\WWWROOT\CHECKSRV'
/**************************************************************************/

/* Feste Variablen */
LogDatei = DATE("S")'.LOG'
FrameDatei = 'index.html'
ServerListe = 'srvliste.htm'
CheckInfo = 'chkinfo.htm'
ServerInfo = ''
FehlerInfo = 'index.html'
SuchWort = 'Prfe'

/* Alle alten HTML-Dateien lschen */
call SysFileTree ZielPfad'\*.*','FoundOld.','FO'

if FoundOld.0 > 0 then
   do i=1 to FoundOld.0
      call SysFileDelete(FoundOld.i)
   end /* do */

/* Suche Tages-LogDatei */
call SysFileTree QuellPfad'\'LogDatei,'FoundLog.''FO'

if FoundLog.0 = 0 then
   do 
      call MakeFehlerInfo
   end /* do */
else
   do 
      call SysFileSearch SuchWort,QuellPfad'\'LogDatei,'FoundWort.','N'
      if FoundWort.0 > 0 then
         do 
            FirstServer = substr(word(FoundWort.1,4),1,length(word(FoundWort.1,4))-3)
            call MakeFrame
            call MakeServerListe
            call MakeCheckInfo
            call MakeServerTxt
         end /* do */
      else
         do 
            call MakeFehlerInfo
         end /* do */
   end /* do */

EXIT

MakeFrame:
call lineout ZielPfad'\'FrameDatei,'<HTML>'
call lineout ZielPfad'\'FrameDatei,'<HEAD>'
call lineout ZielPfad'\'FrameDatei,'<META NAME="description" CONTENT="Frameset Server-Statistik">'
call lineout ZielPfad'\'FrameDatei,'<META NAME="author" CONTENT="Thomas Nolte">'
call lineout ZielPfad'\'FrameDatei,'<META NAME="keywords" CONTENT="Frame, Server, Statistik">'
call lineout ZielPfad'\'FrameDatei,'<META NAME="generator" CONTENT="REXX for OS/2 Warp 4">'
call lineout ZielPfad'\'FrameDatei,'<TITLE>Server-Statistik</TITLE>'
call lineout ZielPfad'\'FrameDatei,'</HEAD>'
call lineout ZielPfad'\'FrameDatei,' '
call lineout ZielPfad'\'FrameDatei,'<FRAMESET COLS="20%,80%">'
call lineout ZielPfad'\'FrameDatei,'      <FRAME SRC="'ServerListe'" NAME="Server-Liste" SCROLLING=YES MARGINWIDTH=0>'
call lineout ZielPfad'\'FrameDatei,'   <FRAMESET ROWS="10%,90%">'
call lineout ZielPfad'\'FrameDatei,'      <FRAME SRC="'CheckInfo'" NAME="Info-Fenster" SCROLLING=NO>'
call lineout ZielPfad'\'FrameDatei,'      <FRAME SRC="'FirstServer'.htm" NAME="Server" SCROLLING=YES>'
call lineout ZielPfad'\'FrameDatei,'   </FRAMESET>'
call lineout ZielPfad'\'FrameDatei,'</FRAMESET>'
call lineout ZielPfad'\'FrameDatei,' '
call lineout ZielPfad'\'FrameDatei,'</BODY>'
call lineout ZielPfad'\'FrameDatei,'<!-- HTML document ends -->'
call lineout ZielPfad'\'FrameDatei,'</HTML>'
call lineout(ZielPfad'\'FrameDatei)
return

MakeServerListe:
call lineout ZielPfad'\'ServerListe,'<HTML>'
call lineout ZielPfad'\'ServerListe,'<HEAD>'
call lineout ZielPfad'\'ServerListe,'<TITLE>Server-Liste</TITLE>'
call lineout ZielPfad'\'ServerListe,'</HEAD>'
call lineout ZielPfad'\'ServerListe,'<BODY TEXT="#000000" BGCOLOR="#cccccc" LINK="#0000ff" VLINK="#000096" ALINK="#ff0000">'
call lineout ZielPfad'\'ServerListe,' '
call lineout ZielPfad'\'ServerListe,'<H2>Server</H2>'
call lineout ZielPfad'\'ServerListe,' '
call lineout ZielPfad'\'ServerListe,'<BASE target="Server">'
call lineout ZielPfad'\'ServerListe,' '
do i=1 to FoundWort.0
   Server = substr(word(FoundWort.i,4),1,length(word(FoundWort.i,4))-3)
   call lineout ZielPfad'\'ServerListe,'<A HREF="'Server'.htm" >'Server'</A><BR>'
end /* do */
call lineout ZielPfad'\'ServerListe,' '
call lineout ZielPfad'\'ServerListe,'</BODY>'
call lineout ZielPfad'\'ServerListe,'<!-- HTML document ends -->'
call lineout ZielPfad'\'ServerListe,'</HTML>'
call lineout(ZielPfad'\'ServerListe)
return

MakeCheckInfo:
call lineout ZielPfad'\'CheckInfo,'<HTML>'
call lineout ZielPfad'\'CheckInfo,'<HEAD>'
call lineout ZielPfad'\'CheckInfo,'<TITLE>Server-Check Informationen</TITLE>'
call lineout ZielPfad'\'CheckInfo,'</HEAD>'
call lineout ZielPfad'\'CheckInfo,'<BODY TEXT="#000000" BGCOLOR="#cccccc" LINK="#0000ff" VLINK="#000096" ALINK="#ff0000">'
call lineout ZielPfad'\'CheckInfo,' '
call lineout ZielPfad'\'CheckInfo,'<CENTER><H2>Server-Check vom 'DATE("L")'</H2></CENTER>'
call lineout ZielPfad'\'CheckInfo,' '
call lineout ZielPfad'\'CheckInfo,'</BODY>'
call lineout ZielPfad'\'CheckInfo,'<!-- HTML document ends -->'
call lineout ZielPfad'\'CheckInfo,'</HTML>'
call lineout(ZielPfad'\'CheckInfo)
return

MakeServerTxt:
do i=1 to FoundWort.0
   Server = substr(word(FoundWort.i,4),1,length(word(FoundWort.i,4))-3)

   /* Schreibe Anfang der HTML-Datei */
   call lineout ZielPfad'\'Server'.htm','<HTML>'
   call lineout ZielPfad'\'Server'.htm','<HEAD>'
   call lineout ZielPfad'\'Server'.htm','<TITLE>Server 'Server'</TITLE>'
   call lineout ZielPfad'\'Server'.htm','</HEAD>'
   call lineout ZielPfad'\'Server'.htm','<BODY TEXT="#000000" BGCOLOR="#cccccc" LINK="#0000ff" VLINK="#000096" ALINK="#ff0000">'
   call lineout ZielPfad'\'Server'.htm',' '
   call lineout ZielPfad'\'Server'.htm','<PRE>'

   do word(FoundWort.i,1)
      Zeile = linein(QuellPfad'\'LogDatei,,1)
      call ChangeUmlaut
   end /* do */
   call lineout ZielPfad'\'Server'.htm',Zeile
   if i < FoundWort.0 then
      do 
         j = i+1
         Anzahl = word(FoundWort.j,1) - word(FoundWort.i,1)
         do Anzahl-1
            Zeile = linein(QuellPfad'\'LogDatei,,1)
            Zeile = TRANSLATE(Zeile,'=','')
            call ChangeUmlaut
            call lineout ZielPfad'\'Server'.htm',Zeile
         end /* do */
      end /* do */
   else
      do while lines(QuellPfad'\'LogDatei)
         Zeile = linein(QuellPfad'\'LogDatei,,1)
         Zeile = TRANSLATE(Zeile,'=','')
         call ChangeUmlaut
         call lineout ZielPfad'\'Server'.htm',Zeile
      end /* do */

   /* Schreibe Ende der HTML-Datei */
   call lineout ZielPfad'\'Server'.htm','</PRE>'
   call lineout ZielPfad'\'Server'.htm',' '
   call lineout ZielPfad'\'Server'.htm','</BODY>'
   call lineout ZielPfad'\'Server'.htm','<!-- HTML document ends -->'
   call lineout ZielPfad'\'Server'.htm','</HTML>'
   call lineout(ZielPfad'\'Server'.htm')

   call lineout(QuellPfad'\'LogDatei)
   call lineout(ZielPfad'\'Server'.htm')
end /* do */
return

ChangeUmlaut:
UmlautOrt = pos('',Zeile)
do while UmlautOrt > 0
   Zeile = substr(Zeile,1,UmlautOrt-1)'&auml;'substr(Zeile,UmlautOrt+1)
   UmlautOrt = pos('',Zeile)
end /* do */
UmlautOrt = pos('',Zeile)
do while UmlautOrt > 0
   Zeile = substr(Zeile,1,UmlautOrt-1)'&ouml;'substr(Zeile,UmlautOrt+1)
   UmlautOrt = pos('',Zeile)
end /* do */
UmlautOrt = pos('',Zeile)
do while UmlautOrt > 0
   Zeile = substr(Zeile,1,UmlautOrt-1)'&uuml;'substr(Zeile,UmlautOrt+1)
   UmlautOrt = pos('',Zeile)
end /* do */
UmlautOrt = pos('<',Zeile)
do while UmlautOrt > 0
   Zeile = substr(Zeile,1,UmlautOrt-1)'&lt;'substr(Zeile,UmlautOrt+1)
   UmlautOrt = pos('<',Zeile)
end /* do */
UmlautOrt = pos('>',Zeile)
do while UmlautOrt > 0
   Zeile = substr(Zeile,1,UmlautOrt-1)'&gt;'substr(Zeile,UmlautOrt+1)
   UmlautOrt = pos('>',Zeile)
end /* do */
return

MakeFehlerInfo:
call lineout ZielPfad'\'FehlerInfo,'<HTML>'
call lineout ZielPfad'\'FehlerInfo,'<HEAD>'
call lineout ZielPfad'\'FehlerInfo,'<TITLE>Server-Check Informationen</TITLE>'
call lineout ZielPfad'\'FehlerInfo,'</HEAD>'
call lineout ZielPfad'\'FehlerInfo,'<BODY TEXT="#000000" BGCOLOR="#cccccc" LINK="#0000ff" VLINK="#000096" ALINK="#ff0000">'
call lineout ZielPfad'\'FehlerInfo,' '
call lineout ZielPfad'\'FehlerInfo,'<CENTER><H2>Es sind keine aktuellen Informationen<BR>'
call lineout ZielPfad'\'FehlerInfo,'vom Server-Check verf&uuml;gbar!</H2></CENTER>'
call lineout ZielPfad'\'FehlerInfo,' '
call lineout ZielPfad'\'FehlerInfo,'</BODY>'
call lineout ZielPfad'\'FehlerInfo,'<!-- HTML document ends -->'
call lineout ZielPfad'\'FehlerInfo,'</HTML>'
call lineout(ZielPfad'\'FehlerInfo)
return

